// Библиотека работы с пультом 315/433
#include <RCSwitch.h>
RCSwitch mySwitch = RCSwitch();

// Коды клавиш от двух пультов, с которых будет управлние
#define RC_CODE1 0x5C00
#define RC_CODE2 0x65B1

// Значения уровней диммирования каждого режима
#define PWM_LEVEL1 255
#define PWM_LEVEL2 170
#define PWM_LEVEL3 64


int ledPin = 3;    // Выход ШИМ на диммер
int powerPin = 9; // Управление драйвером через симистор
 
 
uint8_t pwmLevel = 255; 
boolean pwmStat  = false;
boolean pwmInc   = true;
uint8_t pwmMode  = 1;
 
uint32_t ms, ms1 = 0; 
boolean press_flag = false; 
uint16_t press_cnt = 0;
 
 
 
void setup()
{
    mySwitch.enableReceive(0);  
    pinMode(ledPin, OUTPUT);      
    pinMode(powerPin, OUTPUT);      
    digitalWrite(powerPin,LOW);
    Serial.begin(9600);
    delay(1000);
    Serial.println("Start");
}
 
 
void loop()
{    
ms = millis();
// Принимаем коды с радиопульта
   if (mySwitch.available()) {
      int value = mySwitch.getReceivedValue();
      if( value == RC_CODE1 || value == RC_CODE2 ){
//         Serial.print("code=0x");
//         Serial.println(value,HEX);
         press_flag = true;
      }
      mySwitch.resetAvailable();
   }
    
    
    
// Задержка 250мс для устранения дребезга
//    if( BT1.check() )press_flag = true;
    if( ( ms - ms1 ) >200 || ms < ms1 ){  
       if( press_flag ){
          press_cnt++;
// Переключаем один из трех режимов          
          if( pwmStat ){
             if( press_cnt == 5 ){
                switch( pwmMode ){
                   case 1:
                      pwmMode = 2;
                      pwmLevel = PWM_LEVEL2;
                      break;
                   case 2:
                      pwmMode = 3;
                      pwmLevel = PWM_LEVEL3;
                      break;
                   default:
                      pwmMode = 1;
                      pwmLevel = PWM_LEVEL1;
                      break;
                }
                Serial.print("Mode=");
                Serial.print(pwmInc);
                Serial.print(" level=");
                Serial.print(pwmLevel);
                Serial.print(" count=");
                Serial.println(press_cnt);
                analogWrite(ledPin, pwmLevel);
               
             }//end if press_cnt == 5
          }//end if PwmStat
       } //end if press_flag
       else {
          if( press_cnt > 0 && press_cnt < 5 ){
// Включаем/отключаем лампу 
            pwmStat = !pwmStat;
             if( pwmStat ) {
                  digitalWrite(powerPin,HIGH);
                  analogWrite(ledPin, pwmLevel);
             }
             else  {
                  analogWrite(ledPin, 0);
                  digitalWrite(powerPin,LOW);
             }
             Serial.print("Press=");
             Serial.print(pwmStat);
             Serial.print(" level=");
             Serial.print(pwmLevel);
             Serial.print(" count=");
             Serial.println(press_cnt);
         }

          press_cnt = 0;
       }
       ms1 = ms;
       press_flag = false;
    }  
         

  
  
/*
  int i;
   for( i=0; i<255; i+=10){
       analogWrite(ledPin, i); // analogRead возвращает значения от 0 до 1023, analogWrite должно быть в диапозоне от 0 до 255
       delay(200);
      }  
   delay(5000);   
   for( i=255; i>=0; i-=10){
       analogWrite(ledPin, i); // analogRead возвращает значения от 0 до 1023, analogWrite должно быть в диапозоне от 0 до 255
       delay(200);
      }  
   delay(5000);   
   
*/
//   int i = ;
}
